Description

When specifying the sorting condition of Week column and Date column in the custom query, it doesn't sort well.

Defining a custom query
List of spent time with custom query
Associated revisions

Revision 20634 - 2020-12-12 04:32 - Go MAEDA

Spent time details are displayed in incorrect order when sorted by week and date (#33952).

Patch by Yuichi HARADA.

History

#1 - 2020-09-03 04:43 - Yuichi HARADA

The sort condition Date(:spent_on) and Week(:tweek), defined by app/models/time_entry_query.rb( 

source:trunk/app/models/time_entry_query.rb#L24 ) are the same table columns.

# Date

QueryColumn.new(:spent_on, :sortable => ["#{TimeEntry.table_name}.spent_on", "#{TimeEntry.table_name}

.created_on"], :default_order => 'desc', :groupable => true),

# Week

QueryColumn.new(:tweek, :sortable => ["#{TimeEntry.table_name}.spent_on", "#{TimeEntry.table_name}.created_on"

], :caption => :label_week),

#2 - 2020-09-03 04:53 - Yuichi HARADA

- File fixed-33952.patch added

I think the following patch will fix the problem.

diff --git a/app/models/time_entry_query.rb b/app/models/time_entry_query.rb

index c8f8eeaeb..c5c2099ad 100644

--- a/app/models/time_entry_query.rb

+++ b/app/models/time_entry_query.rb

@@ -25,7 +25,7 @@ class TimeEntryQuery < Query

     QueryColumn.new(:project, :sortable => "#{Project.table_name}.name", :groupable => true),

     QueryColumn.new(:spent_on, :sortable => ["#{TimeEntry.table_name}.spent_on", "#{TimeEntry.table_name}.cre

ated_on"], :default_order => 'desc', :groupable => true),

     TimestampQueryColumn.new(:created_on, :sortable => "#{TimeEntry.table_name}.created_on", :default_order =

> 'desc', :groupable => true),

-    QueryColumn.new(:tweek, :sortable => ["#{TimeEntry.table_name}.spent_on", "#{TimeEntry.table_name}.create

d_on"], :caption => :label_week),

+    QueryColumn.new(:tweek, :sortable => ["#{TimeEntry.table_name}.tyear", "#{TimeEntry.table_name}.tweek"], 

:caption => :label_week),

     QueryColumn.new(:author, :sortable => lambda {User.fields_for_order_statement}),

     QueryColumn.new(:user, :sortable => lambda {User.fields_for_order_statement}, :groupable => true),

     QueryColumn.new(:activity, :sortable => "#{TimeEntryActivity.table_name}.position", :groupable => true),

#3 - 2020-11-17 16:12 - Go MAEDA
- Status changed from New to Confirmed

#4 - 2020-11-30 11:02 - Go MAEDA

- Target version set to Candidate for next minor release

#5 - 2020-12-03 16:06 - Go MAEDA

- Target version changed from Candidate for next minor release to 4.1.2

I have slightly updated the test code.

Setting the target version to 4.1.2.

#6 - 2020-12-10 15:21 - Go MAEDA

- File 33952-v2.patch added

Go MAEDA wrote:

I have slightly updated the test code.

 I forgot to attach a patch.

#7 - 2020-12-10 15:27 - Go MAEDA

- Subject changed from Sorting of Week column and Date column does not work to Sorting spent time details by week and date does not work

#8 - 2020-12-12 04:33 - Go MAEDA

- Subject changed from Sorting spent time details by week and date does not work to Spent time details are displayed in incorrect order when sorted

by week and date

- Status changed from Confirmed to Closed

- Assignee set to Go MAEDA

- Target version changed from 4.1.2 to 4.2.0

- Resolution set to Fixed

Committed the patch. Thank you.

Files

customquery.png 93.1 KB 2020-09-03 Yuichi HARADA

spenttime-with-customquery.png 144 KB 2020-09-03 Yuichi HARADA

fixed-33952.patch 2.83 KB 2020-09-03 Yuichi HARADA

33952-v2.patch 2.79 KB 2020-12-10 Go MAEDA

Powered by TCPDF (www.tcpdf.org)

2025-05-09 2/2

http://www.tcpdf.org

